#include <stdio.h>

void stampa(int N, int v[], int M[][4]);
int verificaCorrispondenza(int v[], int N, int M[][4], int NxN) {
	int i,j,k,corr,somma;
    for (i = 0; i < N; i++) {
        somma = 0;
        for (j = 0; j < 4; j++) {
            somma += M[i][j];
        }
        corr=0;
        for(k=0;k<N;k++)
	        if (somma == v[k]) {
	            corr=1; 
	        }
		if (corr==0) {
            return 0; // Non corrisponde, restituisce 0
        }
    }
    
    return 1; // Corrisponde, restituisce 1
}

int main() {
    // Esempi di test
    int v1[] = {14, 6, 10, 8};
    int M1[][4] = {{1, 2, 3, 4},
                   {0, 1, 2, 3},
                   {4, 3, 6, 1},
                   {2, 2, 2, 2}};
    stampa(4,v1,M1);               
    int risultato1 = verificaCorrispondenza(v1, 4, M1, 4);
    printf("Risultato 1: %s\n", risultato1 ? "Corrisponde" : "Non corrisponde");

    int v2[] = {4, 6, 8};
    int M2[][4] = {{1, 1, 1, 1},
                   {0, 2, 2, 2},
                   {1, 2, 3, 2}};
    stampa(3,v2,M2);               
    int risultato2 = verificaCorrispondenza(v2, 3, M2, 3);
    printf("Risultato 2: %s\n", risultato2 ? "Corrisponde" : "Non corrisponde");

    int v3[] = {10, 20};
    int M3[][4] = {{1, 2, 3, 4},
                   {2, 4, 6, 8}};
    stampa(2,v3,M3);               
    int risultato3 = verificaCorrispondenza(v3, 2, M3, 2);
    printf("Risultato 3: %s\n", risultato3 ? "Corrisponde" : "Non corrisponde");

    int v4[] = {3, 5, 9};
    int M4[][4] = {{1, 1, 1, 1},
                   {0, 2, 2, 2},
                   {1, 2, 7, 2}};
    stampa(3,v4,M4);               
    int risultato4 = verificaCorrispondenza(v4, 3, M4, 3);
    printf("Risultato 4: %s\n", risultato4 ? "Corrisponde" : "Non corrisponde");

    int v5[] = {10, 6, 16, 8};
    int M5[][4] = {{1, 2, 3, 4},
                   {0, 1, 2, 3},
                   {5, 3, 2, 1},
                   {2, 2, 2, 2}};
    stampa(4,v5,M5);               
    int risultato5 = verificaCorrispondenza(v5, 4, M5, 4);
    printf("Risultato 5: %s\n", risultato5 ? "Corrisponde" : "Non corrisponde");

    return 0;
}

void stampa(int N, int v[], int M[][4]) {
	int i,j;
	printf("Vettore\n");
    for (i = 0; i < N; i++) {
    	printf("%d ",v[i]);
    }
    printf("\nMatrice\n");
    for (i = 0; i < N; i++) {
        for (j = 0; j < 4; j++) {
            printf("%d ",M[i][j]);
        }
		printf("\n");
    }
    printf("\n\n");
}

